*****************************************************************************
* Auth  Andreas [Pucko] Plsson
* Desc  A simple assembler example how to use 'ptreplay.library'
*        should be compiled with DevPac 3.2 or changes has to be done.
*        To exit just press CTRL_C
***>> GeNam 3.2 Options
	OPT	AMIGA,CASE,CHKPC,DEBUG,EVEN,O-,OW+,P=68000
	OUTPUT	Ram:Play
***>> Include-files
	INCDIR	Incl:			Path to includefiles
	INCLUDE	Exec/Exec_Lib.I		The Exec calls
	INCLUDE	Dos/Dos.I		The return- & Sigbreak -values
	INCLUDE	Libraries/PTReplay.I	The PTReplay inkludes
	INCLUDE	Libraries/PTReplay_Lib.I
***>> Program Macros
CALL	MACRO				Macro for Librarycalls
	Jsr	_LVO\1(A6)
	ENDM

True	Equ	~0
False	Equ	0
***>> Program start
prStart
	Sub.L	#1,D0			 Remove the last 'return'-
	Move.B	#$00,(A0,D0.L)		character from the command
	Lea	_CmdLin(PC),A5          line and save the pointer
	Move.L	A0,(A5)

	Lea	_PtrNam(PC),A1		 Open ptreplay.library
	MoveQ.L	#PTREPLAYVERSION,D0	Version is specified in the
	MoveA.L	4.W,A6			includefile.
	CALL	OpenLibrary		(libName,version)(a1,d0)
	Lea	_PtrLib(PC),A5		Save the library pointer
	Move.L	D0,(A5)

	Tst.L	D0			Check if open failed
	Bne.S	ptLibOK
	MoveQ.L	#RETURN_FAIL,D0		Return failure and exit
	Bra.S	prExit			programme.

ptLibOK	MoveA.L	D0,A6			Lib opened, go on

	Lea	_CmdLin(PC),A0		 The name of the module is
	MoveA.L	(A0),A0			in the commandline (hopefully)
	CALL	PTLoadModule		(name)(A0)
	Lea	_PtrMod(PC),A5		Save the returned modulepointer
	Move.L	D0,(A5)
	Tst.L	D0			Check if no errors
	Beq.S	prClose

	MoveA.L	D0,A0			 Play the module
	CALL	PTPlay			(module)(A0)

	MoveQ.L	#0,D0			 Set up a wait for CTRL_C
	BSet	#SIGBREAKB_CTRL_C,D0	so we can exit when finished
	MoveA.L	4.W,A6			listening.
	CALL	Wait			(signalSet)(d0)

	Lea	_PtrMod(PC),A0		 Obtain the modulepointer
	MoveA.L	(A0),A0			and stop the playing.
	Lea	_PtrLib(PC),A6
	MoveA.L	(A6),A6
	CALL	PTStop			(module)(A0)

	Lea	_PtrMod(PC),A0		 Flush out the loaded module
	MoveA.L	(A0),A0
	CALL	PTUnloadModule		(module)(A0)

prClose	Lea	_PtrLib(PC),A1
	MoveA.L	(A1),A1
	MoveA.L	4.W,A6	
	CALL	CloseLibrary		(library)(a1)
prExit	RTS
_CmdLin	Dc.L	$00000000
_PtrNam	Dc.B	'ptreplay.library',$00
_PtrLib	Dc.L	$00000000
_PtrMod	Dc.L	$00000000
